package com.objis.demoaspectj.aspects;

import com.objis.demoaspectj.banque.CompteBancaire;
import com.objis.demoaspectj.securite.ServiceAuthentification;


public aspect SecurityAspect {
	private ServiceAuthentification authenticator = new ServiceAuthentification();

  declare warning
    : call(void ServiceAuthentification.authenticate()) && !within(SecurityAspect)
    : "Un aspect est dja configur pour l'authentification !!";

	pointcut secureAccess()
        : execution(* CompteBancaire.retrait(..));

	before() : secureAccess() {
		System.out.println("Authentification de l'utilisateur :");
		authenticator.authenticate();
	}
}